﻿<AML>
 <Item type="Method" id="34EFE405A70F4432806173D9E50D5A5E" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[            /* *****************************************************************************
            Method Name:			acc_sale_bill_gl_post
            Created By/Company:		SolidCAD 
            Creation Date:			2018-01-23
            Description:
                When promote "Post To GL",
                -Getting Required Information to add Journal.

            Hooks:
                Type:		Life Cycle Map : acc_sale_LC
                Event:		Server Methods ( Pre )
                
            Revisions:
                Rev Date		Modified By			Description
                YYYY-MM-DD		***					Initial creation
            ***************************************************************************** */

            //WARNING: DO NOT FORGET TO DISABLE THIS IN A PRODUCTION ENVIRONMENT!!!
            //if(System.Diagnostics.Debugger.Launch()) System.Diagnostics.Debugger.Break();

            string MethodName = "acc_sale_bill_gl_post";

            //***** GRANT IDENTITY PRIVILEGES
            // grantIdentityPrivileges("Super User"); // If this is enabled always revoke the privileges in the Finally below.
            //*******************************
            Innovator myInnovator = this.getInnovator();
            Item result = this; // default return value.

            try
            {
                var _id = this.getID();
                string _headerid = "";
                string receivable_account = "";
                string tax_name = "";
                string tax_account_id = "";

                decimal base_gst_amount = 0;
                decimal base_sub_amount = 0;
                decimal base_total_amount = 0;

                decimal sg_gst_amount = 0;
                decimal sg_sub_amount = 0;
                decimal sg_total_amount = 0;

                var invoice_id = this.getProperty("id", "");

                var pop_sub_amount = this.getProperty("pop_sub_amount", "");
                var pop_gst_amount = this.getProperty("pop_gst_amount", "");

                var pop_currency = this.getProperty("pop_currency", "");
                var pop_total_amount = this.getProperty("pop_total_amount", "");
                var pop_operator = this.getProperty("pop_currency_operator", "");
                var pop_rate = this.getProperty("pop_currency_rate", "");

                var sop_customer = this.getProperty("sop_customer", "");
                var sop_invoice_date = this.getProperty("sop_invoice_date", "");
                var sop_invoice_no = this.getProperty("sop_invoice_no", "");

                var acc_account = this.getProperty("acc_account", "");
                var acc_tax = this.getProperty("acc_tax", "");
                var acc_project = this.getProperty("acc_project", "");
                var acc_department = this.getProperty("acc_department", "");
                var sop_invoice_desc = this.getProperty("sop_invoice_desc", "");
                var pop_gst_percent = this.getProperty("pop_gst_percent", "");
                var s_pop_gst_percent = "Tax  " + pop_gst_percent + "%";

                /*Start convert to base currency*/
                if (pop_operator == "*")
                {
                    base_gst_amount = Convert.ToDecimal(pop_gst_amount) / Convert.ToDecimal(pop_rate);
                    base_sub_amount = Convert.ToDecimal(pop_sub_amount) / Convert.ToDecimal(pop_rate);
                    base_total_amount = base_gst_amount + base_sub_amount;
                }
                else
                {
                    base_gst_amount = Convert.ToDecimal(pop_sub_amount) * Convert.ToDecimal(pop_rate);
                    base_sub_amount = Convert.ToDecimal(pop_gst_amount) * Convert.ToDecimal(pop_rate);
                    base_total_amount = base_gst_amount + base_sub_amount;
                }
                /*End convert to base currency*/

                /*Start convert to SG currency(Base to SG)*/
                //get SG rate

                var currency_result = myInnovator.applyMethod("acc_SG_currency_info", "<currency_date>" + sop_invoice_date + "</currency_date>");

                var currency_count = currency_result.getItemCount();
                if (currency_count > 0)
                {
                    if (pop_currency != currency_result.getProperty("id", ""))
                    {
                        string sg_rate = currency_result.getProperty("acc_monthly_rate", "");
                        string sg_operator = currency_result.getProperty("acc_operator", "");
                        if (sg_operator == "*")
                        {
                            sg_gst_amount = Convert.ToDecimal(base_gst_amount) * Convert.ToDecimal(sg_rate);
                            sg_sub_amount = Convert.ToDecimal(base_sub_amount) * Convert.ToDecimal(sg_rate);
                            sg_total_amount = sg_gst_amount + sg_sub_amount;
                        }
                        else
                        {
                            sg_gst_amount = Convert.ToDecimal(base_gst_amount) / Convert.ToDecimal(sg_rate);
                            sg_sub_amount = Convert.ToDecimal(base_sub_amount) / Convert.ToDecimal(sg_rate);
                            sg_total_amount = sg_gst_amount + sg_sub_amount;
                        }
                    }
                    else //if Invoice Currency is already SGD
                    {
                        sg_gst_amount = Convert.ToDecimal(pop_gst_amount);
                        sg_sub_amount = Convert.ToDecimal(pop_sub_amount);
                        sg_total_amount = Convert.ToDecimal(pop_total_amount);
                    }
                }

                /*End convert to SG currency(Base to SG)*/

                // Get default setup values from Company Setup 
                var erp_company_setup = myInnovator.newItem("erp_company_setup", "get");
                var result_data = erp_company_setup.apply();
                var result_count = result_data.getItemCount();
                if (result_count > 0)
                {
                    var setup = result_data.getItemByIndex(0);
                    receivable_account = setup.getProperty("erp_ar_account", "");
                }

                Item tax_result = myInnovator.applySQL(
                    "SELECT * " +
                    "FROM  innovator.[ACC_TAXTEMPLATE] " +
                    "WHERE id='" + acc_tax + "'");

                var tax_count = tax_result.getItemCount();
                if (tax_count > 0)
                {
                    tax_name = tax_result.getProperty("acc_taxname");
                    tax_account_id = tax_result.getProperty("acc_saletaxcollect");
                }

                /*Start save to journal*/
                Item journalHeader = myInnovator.newItem("acc_journal_header", "add");
                journalHeader.setProperty("acc_date", sop_invoice_date);
                journalHeader.setProperty("acc_reftransactionid", _id);
                journalHeader.setProperty("acc_transactiontype", "Sale");
                journalHeader.setProperty("acc_customerid", sop_customer);
                journalHeader.setProperty("acc_refno", sop_invoice_no);
                journalHeader.setProperty("acc_project", acc_project);
                journalHeader.setProperty("acc_department", acc_department);
                journalHeader.setProperty("acc_amount", pop_total_amount);
                journalHeader.setProperty("acc_credit_amount", pop_total_amount);
                journalHeader.setProperty("acc_sop_voucher_reference", _id);
                journalHeader = journalHeader.apply();
                _headerid = journalHeader.getID();

                Item detailsAR = myInnovator.newItem("acc_journal_details", "add");
                detailsAR.setProperty("acc_accountid", receivable_account);
                Item acc_accountdetail_code_item_receiable = myInnovator.getItemById("acc_AccountDetails", receivable_account);
                detailsAR.setProperty("acc_accountdetail_code", acc_accountdetail_code_item_receiable.getProperty("acc_accountdetail_code", ""));
                detailsAR.setProperty("acc_credit", "0");
                detailsAR.setProperty("acc_debit", Convert.ToString(base_total_amount));
                detailsAR.setProperty("acc_sg_credit", "0");
                detailsAR.setProperty("acc_sg_debit", Convert.ToString(sg_total_amount));
                detailsAR.setProperty("acc_systemaccountid", "Account Receivable");
                detailsAR.setProperty("acc_amount_currency", pop_total_amount);
                detailsAR.setProperty("acc_currency", pop_currency);
                detailsAR.setProperty("acc_description", "/");
                detailsAR.setProperty("source_id", _headerid);
                detailsAR.apply();

                Item detailsSale = myInnovator.newItem("acc_journal_details", "add");
                detailsSale.setProperty("acc_accountid", acc_account);
                Item acc_accountdetail_code_item_sale = myInnovator.getItemById("acc_AccountDetails", acc_account);
                detailsSale.setProperty("acc_accountdetail_code", acc_accountdetail_code_item_sale.getProperty("acc_accountdetail_code", ""));
                detailsSale.setProperty("acc_credit", Convert.ToString(base_sub_amount));
                detailsSale.setProperty("acc_debit", "0");
                detailsSale.setProperty("acc_sg_credit", Convert.ToString(sg_sub_amount));
                detailsSale.setProperty("acc_sg_debit", "0");
                detailsSale.setProperty("acc_systemaccountid", "Sale");
                detailsSale.setProperty("acc_amount_currency", pop_sub_amount);
                detailsSale.setProperty("acc_currency", pop_currency);
                detailsSale.setProperty("acc_description", sop_invoice_desc);
                detailsSale.setProperty("source_id", _headerid);
                detailsSale.apply();

                if (base_gst_amount > 0)
                {
                    Item detailsTax = myInnovator.newItem("acc_journal_details", "add");
                    detailsTax.setProperty("acc_accountid", tax_account_id);
                    Item acc_accountdetail_code_item_tax = myInnovator.getItemById("acc_AccountDetails", tax_account_id);
                    detailsTax.setProperty("acc_accountdetail_code", acc_accountdetail_code_item_tax.getProperty("acc_accountdetail_code", ""));
                    detailsTax.setProperty("acc_credit", Convert.ToString(base_gst_amount));
                    detailsTax.setProperty("acc_debit", "0");
                    detailsTax.setProperty("acc_sg_credit", Convert.ToString(sg_gst_amount));
                    detailsTax.setProperty("acc_sg_debit", "0");
                    detailsTax.setProperty("acc_systemaccountid", tax_name);
                    detailsTax.setProperty("acc_amount_currency", pop_gst_amount);
                    detailsTax.setProperty("acc_currency", pop_currency);
                    detailsTax.setProperty("acc_description", s_pop_gst_percent);
                    detailsTax.setProperty("source_id", _headerid);
                    detailsTax.apply();
                }

                /*End save to journal*/

                /*Start Add related journal into analytical account */
                if (acc_project != "")
                {
                    Item analytical_account = myInnovator.newItem("acc_analytical_account", "get");
                    analytical_account.setProperty("acc_analytical_id", acc_project);
                    analytical_account.setPropertyCondition("acc_analytical_id", "eq");
                    analytical_account = analytical_account.apply();
                    if (!analytical_account.isError() && analytical_account.getItemCount() > 0)
                    {
                        Item relationship = myInnovator.newItem("acc_analytical_account_journal", "add");
                        relationship.setRelatedItem(journalHeader);
                        analytical_account.addRelationship(relationship);
                        analytical_account = analytical_account.apply();
                        if (analytical_account.isError())
                        {
                            return myInnovator.newError(analytical_account.getErrorDetail());
                        }
                    }
                }
                /*End Add related journal into analytical account */

                /*Start Convert All amount in Invoice to SG and record it/update journal entry number/owing amount*/
                
                var update_query = "UPDATE innovator.[sop_sale_invoice]" +
                    " SET pop_sg_sub_amount=" + sg_sub_amount + "," +
                    " pop_sg_gst_amount=" + sg_gst_amount + "," +
                    " pop_sg_total_amount=" + sg_total_amount + "," +
                     "acc_journal_entry='" + _headerid + "' ," +
                     "pop_invoice_status='Post To GL' ," +
                    " sop_owing_amount=" + pop_total_amount +
                    " WHERE id='" + _id + "'";

                Item sop_sale_invoice_update = myInnovator.applySQL(update_query);

                if (sop_sale_invoice_update.isError())
                    return myInnovator.newError("Error in updating sop_sale_invoice.");
                /*End Convert All amount in Invoice to SG and record it/update journal entry number/owing amount*/

            }
            catch (System.Exception ex)
            {
                result = myInnovator.newError(string.Format("SYSTEM EXCEPTION in method {0}\n{1}", MethodName, ex.Message));
                ////result.setErrorCode("0");		//only use if this method is called from another method
            }
            finally
            {
                //**** REVOKE IDENTITY PRIVILEGES
                // revokeIdentityPrivileges();
                //*******************************
            }

            return result;
        }
        /// <summary>
        /// This section is to allow the current method to assume the privileges of a specific identity.
        /// For instance calling: grantIdentityPrivileges("Aras PLM"); will allow this method all of the
        /// rights of the Aras PLM identity.
        /// The revokeIdentityPrivileges() method will removed the privileges added for this method. It
        /// must be called from before the method exits. Most likely in the Finally of the main method code.
        /// If different identity privileges must be granted a second time within the same method, first use
        /// revokeIdentityPrivileges() to remove the first privileges before granting new ones.
        /// </summary>

        private string AssignedIdentity;

        /// <summary>
        /// If required, call this helper function to run this method as another Identity. 
        /// Ensure that you call the revokeIdentityPrivileges helper function in the 
        /// finally block to revoke the Identity privilege when this method completes.
        /// </summary>
        public void grantIdentityPrivileges(string assignedIdent)
        {
            if (!string.IsNullOrEmpty(AssignedIdentity))
            {
                revokeIdentityPrivileges();
            }

            Aras.Server.Security.Identity secIdentity = Aras.Server.Security.Identity.GetByName(assignedIdent);
            if (Aras.Server.Security.Permissions.GrantIdentity(secIdentity))
            {
                AssignedIdentity = assignedIdent;
            }
        }

        /// <summary>
        /// If you granted security privileges, then you need to ensure that you revoke the privilege.
        /// </summary>
        public void revokeIdentityPrivileges()
        {
            if (AssignedIdentity != null)
            {
                Aras.Server.Security.Permissions.RevokeIdentity(Aras.Server.Security.Identity.GetByName(AssignedIdentity));
                AssignedIdentity = null;
            }]]></method_code>
  <method_type>C#</method_type>
  <name>acc_sale_bill_gl_post</name>
 </Item>
</AML>